//
//  AudioProtocols.swift
//  VKExt
//
//  Created programmist_NA on 23.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import Foundation
import UIKit
import SwiftyVK
import SwiftyJSON
import KDEAudioPlayer

//MARK: Wireframe -
protocol AudioWireframeProtocol: class {
    
}
//MARK: Presenter -
protocol AudioPresenterProtocol: class {
    var documentsDirectoryURL: URL { get }
    func start(token: String, secret: String, request: TestAudioItem.Model.Request.RequestType)
    func onEvent(message: String, _ style: MessageViewState)
    func onError(message: String, _ style: MessageViewState)
    func onLoaded(isErrored: Bool, errorCode: Int?)
    func onSave(audio: Audio, at indexPath: IndexPath)
    func onFinishDownload(at indexPath: IndexPath)
    func onProgressChanged(value: Float, at indexPath: IndexPath?)
    func onLogin(login: String, password: String)
    func presentData(response: TestAudioItem.Model.Response.ResponseType)
}

//MARK: Interactor -
protocol AudioInteractorProtocol: class {
    var audioCount: Int { get }
    var items: [JSON] { get }
    var presenter: AudioPresenterProtocol?  { get set }
    func start(token: String, secret: String, request: TestAudioItem.Model.Request.RequestType)
    func makeRequest(token: String, secret: String, request: TestAudioItem.Model.Request.RequestType)
    func save(audio: Audio)
    func auth(login: String, password: String)
}

//MARK: View -
protocol AudioViewProtocol: class {
    var presenter: AudioPresenterProtocol?  { get set }
    func showStatusError(message: String, error: ErrorLocalize?, _ style: MessageViewState, with isLoading: Bool)
    func finish()
    func displayData(viewModel: TestAudioItem.Model.ViewModel.ViewModelData)
    func handleLoading(from isNeed: Bool)
    func setProgress(from value: Float, at indexPath: IndexPath)
    func setProgressHidden(from value: Bool, at indexPath: IndexPath)
    func showError(message: String, image: UIImage?)
    func hideError()
}
